import type * as RDF from '@rdfjs/types';
import type { Algebra } from 'sparqlalgebrajs';
import type { ICompleteSharedContext } from '../evaluators/evaluatorHelpers/BaseExpressionEvaluator';
import type { SetFunction } from '../util/Consts';
import type { BaseAggregator } from './BaseAggregator';
export interface IAggregatorClass {
    new (expr: Algebra.AggregateExpression, sharedContext: ICompleteSharedContext): BaseAggregator<any>;
    emptyValue: () => RDF.Term | undefined;
}
export declare const aggregators: Readonly<{
    [key in SetFunction]: IAggregatorClass;
}>;
